# Pull Request Template

Please remove everything except for the template best matching your pull request
type below. Then ensure you fill in the template, to the best of your abilities
before submitting.

## Table of Contents

* [Code of Conduct](#code-of-conduct)
* [Test or Documentation Addition](#test-or-documentation-addition)
* [Bug Fix](#bug-fix)
* [Proposal Implementation](#proposal-implementation)

### Code of Conduct

TerraFX and everyone contributing (this includes issues, pull requests, the
wiki, etc) must abide by the [CODE_OF_CONDUCT](CODE_OF_CONDUCT.md).
Instances of abusive, harassing, or otherwise unacceptable behavior may be
reported by contacting the project team at admin@terrafx.dev.

## Test or Documentation Addition

These types of additions should just have a brief summary of what they are
doing. They do not need an attached issue. They should be prefixed with `[TEST]`
or `[DOCS]`.

## Bug Fix

Bug fixes should have a brief summary of the change as well as a link to the
issue they are resolving. They should be prefixed with `[BUG]` and should
include a regression test to ensure the bug is not introduced again in the
future.

## Proposal Implementation

Proposal implementations should also have a brief summary of the change and a
link to the proposal they are implementing. They should be prefixed with
`[IMPL]`. Ideally, they will also come with basic unit, functional, or
integration tests that validate they work as intended.
